
/*********************************************************************
* Copyright (c) 2017 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Gorka Benguria                            Tecnalia
* Iaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.DECIDEh2020.optimus.editors;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.json.simple.JSONArray;
//import org.json.simple.JSONException;
import org.json.simple.JSONObject;
//import org.json.parser.JSONParser;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

public class Classification extends Composite {

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */

	/** The text widget used in page 2. */
	private StyledText text;
	/** The font chosen in page 1. */
	private Font font;
	private Text text_1;
	private Composite text_2;
	public int microservicesNumber = 0;

	public int y = 5;
	public String newcontent;


	
	public Classification(Composite parent, int style) {
		super(parent, style);
		
		
		Label lblAppName = new Label(this, SWT.NONE);
		lblAppName.setBounds(10, 10, 55, 15);
		lblAppName.setText("App name");
		
		text_1 = new Text(this, SWT.BORDER);
		text_1.setBounds(74, 10, 76, 21);
		
		text_1.addFocusListener(new FocusListener() {
		
			@Override
			public void focusGained(FocusEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void focusLost(FocusEvent arg0) {
				newcontent = text_1.getText();
    			optimus.appjson.put("id", (int) (Math.random()*1000));
    			optimus.appjson.put("name", newcontent);
			
			}});
		
		

		
		
		Button btnAddMicroservice = new Button(this, SWT.NONE);
		btnAddMicroservice.setBounds(181, 10, 130, 25);
		btnAddMicroservice.setText("Add microservice");
		
		ScrolledComposite scrolledComposite = new ScrolledComposite(this, SWT.BORDER | SWT.V_SCROLL);
		scrolledComposite.setTouchEnabled(true);
		scrolledComposite.setShowFocusedControl(true);
		scrolledComposite.setAlwaysShowScrollBars(true);
		scrolledComposite.setExpandVertical(true);
		scrolledComposite.setBounds(10, 48, 753, 596);

		final StyledText styledText = new StyledText(scrolledComposite, SWT.BORDER | SWT.WRAP);
		 scrolledComposite.setContent(styledText);
		    scrolledComposite.setMinSize(styledText.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		    
		    Button btnSave = new Button(this, SWT.NONE);
		    btnSave.setBounds(688, 660, 75, 25);
		    btnSave.setText("Save");
		    
		    btnSave.addSelectionListener(new SelectionAdapter() {
		    	public void widgetSelected(SelectionEvent event) {
		    		
		    		optimus.appjson.put("microservices", optimus.appmicros);
		    		final String FILENAME = optimus.workingDir;
		    		
		    			BufferedWriter bw = null;
		    			FileWriter fw = null;
		    			try {
		    				String content = optimus.appjson.toString();
		    				fw = new FileWriter(FILENAME);
		    				bw = new BufferedWriter(fw);
		    				bw.write(content);
		    			} catch (IOException e) {
		    				e.printStackTrace();
		    			} finally {
		    				try {
		    					if (bw != null)
		    						bw.close();
		    					if (fw != null)
		    						fw.close();

		    				} catch (IOException ex) {
		    					ex.printStackTrace();
		    				}
		    		}
		    	}
		    });
		
		
		    
		    

		btnAddMicroservice.addSelectionListener(new SelectionAdapter() {
		public void widgetSelected(SelectionEvent event) {
			microservicesNumber = microservicesNumber + 1;
		
			text_2 = new Microservice(scrolledComposite, SWT.BORDER, y);
			text_2.setBounds(10, y, 500, 100);
			y = (120* microservicesNumber);
		}
	});

	}
    public void Create_microservices_from_file() {
		if (!(optimus.appjson.isEmpty()))
		{
    	text_1.setText(optimus.appjson.get("name").toString());
    	ScrolledComposite scrolledComposite = new ScrolledComposite(this, SWT.BORDER | SWT.V_SCROLL);
		scrolledComposite.setTouchEnabled(true);
		scrolledComposite.setShowFocusedControl(true);
		scrolledComposite.setAlwaysShowScrollBars(true);
		scrolledComposite.setExpandVertical(true);
		scrolledComposite.setBounds(10, 48, 753, 427);

    	optimus.appjson.get("name").toString();
    	optimus.appmicros.remove("microservices");
    	optimus.appmicros.add(optimus.appjson.get("microservices"));
    	int numbermicr=optimus.appmicros.size();
     	for (int i = 0; i <numbermicr; i++)
    	
    	{
		microservicesNumber = microservicesNumber + 1;
		text_2 = new Microservice(scrolledComposite, SWT.BORDER, y);
		text_2.setBounds(10, y, 500, 100);
		y = (120* microservicesNumber);
   // }
    	}
		}
	}	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
