
/*********************************************************************
* Copyright (c) 2017 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Gorka Benguria                            Tecnalia
* Iaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.DECIDEh2020.optimus.editors;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.json.simple.JSONArray;

import org.json.simple.JSONObject;
import org.eclipse.swt.widgets.Combo;


public class Microservice extends Composite {

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	/** The text widget used in page 2. */
	private StyledText text;
	/** The font chosen in page 1. */
	private Font font;
	private Text text_1;
	private Text text_2;
	private static JSONObject micros;
	private JSONArray DetachR;
	private Text Detach_text;
	private JSONObject DRes;
	

	
	public Microservice(Composite parent, int style, int y) {
		super(parent, style);
		
		Composite compositeMicro = new Composite(this, SWT.NONE);
		compositeMicro.setBounds(1, 0, 437, 83);
		DetachR = new JSONArray();
		
			Label lblMicroserviceName = new Label(compositeMicro, SWT.NONE);
			lblMicroserviceName.setBounds(10, 13, 50, 30);
			lblMicroserviceName.setText("Name");
			text_2 = new Text(compositeMicro, SWT.BORDER);
			text_2.setBounds(69, 13, 200, 21);
			
			Label microserviceID = new Label(compositeMicro, SWT.NONE);
			microserviceID.setText("id");
			microserviceID.setBounds(275, 13, 50, 15);
			microserviceID.setVisible(false);
			
			
			
			Combo ms_type = new Combo(compositeMicro, SWT.NONE);
			ms_type.setItems(new String[] {"Computing", "Computing Public IP"});
			ms_type.setBounds(331, 10, 91, 23);
			ms_type.setText("Computing");
			
			Combo Detach_type = new Combo(compositeMicro, SWT.NONE);
			Detach_type.setItems(new String[] {"Storage. DB", "Storage", "Queue System"});
			Detach_type.setBounds(322, 50, 91, 23);
			Detach_type.setText("Storage");
			
			Button Det_DB = new Button(compositeMicro, SWT.RADIO);
			Det_DB.setSelection(false);
			Det_DB.setBounds(277, 53, 90, 16);
			Det_DB.setText("DB");
			Det_DB.addFocusListener(new FocusListener(){
		    	

				@Override
				public void focusGained(FocusEvent arg0) {
					// TODO Auto-generated method stub
					
				}
				@Override
				public void focusLost(FocusEvent arg0) {
					if (Det_DB.getSelection()) {
						Detach_type.setText("Storage. DB");
											} 
					if (!Det_DB.getSelection()) {Detach_type.setText("Storage");}
					
					if (DRes.get(Detach_type)!=Detach_type.getText())
					{
						
						DetachR.remove(DRes);
						micros.remove(DetachR);
						optimus.appmicros.remove(micros);
						DRes.put("Det_type",Detach_type.getText());
						DetachR.add(DRes);
						optimus.appmicros.add(micros);
					}
					
					

					
				}
			}
					);
			
			Label lblDetachableResource = new Label(compositeMicro, SWT.NONE);
			lblDetachableResource.setBounds(11, 53, 122, 15);
			lblDetachableResource.setText("Detachable Resource");
			Detach_text = new Text(compositeMicro, SWT.BORDER);
			Detach_text.setBounds(143, 47, 117, 21);

			Detach_text.addFocusListener(new FocusListener(){
		    	

				@Override
				public void focusGained(FocusEvent arg0) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void focusLost(FocusEvent arg0) {
					DRes = new JSONObject();
					for (int i=0; i < optimus.appmicros.size(); i++)
						{
						    JSONObject itemArr = (JSONObject)optimus.appmicros.get(i);
						    if (itemArr.get("id").equals(microserviceID.getText()))
						    {
						        break;
						    }
					}
					 
					DRes.put("DetachableResource",Detach_text.getText());
					DRes.put("Det_type",Detach_type.getText());
					
					DetachR.add(DRes);
					micros.put("Detachable_resources",DetachR);
				}
			});
						
			text_2.addFocusListener(new FocusListener() {
		    	

				@Override
				public void focusGained(FocusEvent arg0) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void focusLost(FocusEvent arg0) {
					int id = (int) (Math.random()*1000);
					String idS = String.valueOf(id);
					micros = new JSONObject();

						for (int i=0; i < optimus.appmicros.size(); i++)
						{
						    JSONObject itemArr = (JSONObject)optimus.appmicros.get(i);
						    if (itemArr.get("id").equals(microserviceID.getText()))
						    {
						    	optimus.appmicros.remove(itemArr);
						    	idS = microserviceID.getText();
						        break;

						    }
					}
					 
					
					micros.put("id",idS);
					micros.put("microname", text_2.getText());
					micros.put("ms_type", ms_type.getText());
					optimus.appmicros.add(micros);
					microserviceID.setText(idS);
					microserviceID.setVisible(true);
				}

				private boolean existmicroservice(String text) {
					JSONObject microstemp = new JSONObject();
					microstemp.put("id",text);
					microstemp.put("microname", text_2.getText());
					if (optimus.appmicros.contains(microstemp)) {
						return true;

					} else {
					return false;
					}
				}});
		}
	//});

	//}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
