
/*********************************************************************
* Copyright (c) 2017 Tecnalia.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
* Contributors (in alphabetical order):
* Gorka Benguria                            Tecnalia
* Iaki Etxaniz                             Tecnalia
* Juncal Alonso                             Tecnalia
* Leire Orue-Echevarria                     Tecnalia
* Maria Jose Lopez                          Tecnalia
* Marisa Escalante                          Tecnalia
* Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
**********************************************************************/
package eu.DECIDEh2020.optimus.editors;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
//import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Button;
//import org.eclipse.swt.widgets.Table;
import org.json.simple.JSONArray;
//import org.json.simple.JSONObject;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;

public class Simulation extends Composite {



	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	
	private JSONArray NFRs;
	public Simulation(Composite parent, int style) {
		super(parent, SWT.NONE);
		
		ScrolledComposite scrolledComposite = new ScrolledComposite(this, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setAlwaysShowScrollBars(true);
		scrolledComposite.setBounds(10, 43, 813, 453);
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		Group group = new Group(scrolledComposite, SWT.NONE);
		
		Composite composite = new Composite(group, SWT.NONE);
		composite.setBounds(10, 10, 135, 121);
		
		Label lblNfrEditor = new Label(composite, SWT.NONE);
		lblNfrEditor.setBounds(10, 10, 55, 15);
		lblNfrEditor.setText("NFR Editor");
		NFRs = new JSONArray();
		
		
		Button btnCost_1 = new Button(composite, SWT.CHECK);
		btnCost_1.setBounds(30, 31, 93, 16);
		btnCost_1.setText("Cost");
		
		
		Button btnAvailability_1 = new Button(composite, SWT.CHECK);
		btnAvailability_1.setBounds(30, 53, 93, 16);
		btnAvailability_1.setText("Availability");
		
		
		Button btnLocation_1 = new Button(composite, SWT.CHECK);
		btnLocation_1.setBounds(30, 75, 93, 16);
		btnLocation_1.setText("Location");
		
		
		Button btnSimulate = new Button(group, SWT.NONE);
		btnSimulate.setBounds(185, 62, 75, 25);
		btnSimulate.setText("Simulate");
		
		Composite composite_1 = new Composite(group, SWT.NONE);
		composite_1.setBounds(10, 137, 723, 259);
		
		Label lblNewLabel = new Label(composite_1, SWT.NONE);
		lblNewLabel.setFont(SWTResourceManager.getFont("Calibri", 14, SWT.BOLD));
		lblNewLabel.setBounds(10, 10, 339, 21);
		lblNewLabel.setText("ApplicationDescription JSON file:");
		StyledText simulationText = new StyledText(composite_1, SWT.BORDER);
		simulationText.setBounds(10, 62, 671, 100);
		simulationText.setAlwaysShowScrollBars(true);
		simulationText.setJustify(true);
		simulationText.setLineSpacing(3);
		simulationText.setText("");

		btnSimulate.addSelectionListener(new SelectionAdapter() {
		public void widgetSelected(SelectionEvent event) {
			NFRs.removeAll(NFRs);
			if (btnCost_1.getSelection()) {
				NFRs.add(btnCost_1.getText());
				}
			if (btnAvailability_1.getSelection()) {
				NFRs.add(btnAvailability_1.getText());
				}
			if (btnLocation_1.getSelection()) {
				NFRs.add(btnLocation_1.getText());
				}
			
			optimus.appjson.put("NFRs", NFRs);
			//}
			
			

			ProgressBar progressBar = new ProgressBar(parent, SWT.NONE);
			progressBar.setBounds(103, 18, 170, 17);

			
			
			progressBar.setVisible(true);
			simulationText.setText(optimus.appjson.toString());
			addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
				}
			});
			
		}
	});
		scrolledComposite.setContent(group);
		scrolledComposite.setMinSize(group.computeSize(SWT.DEFAULT, SWT.DEFAULT));

	}
}
